! 1 
! 1 /*
! 2  * An nano-http server. Part of the linux-86 project
! 3  * 
! 4  * Copyright (c) 2001 Harry Kalogirou <harkal@rainbow.cs.unipi.gr>
! 5  *
! 6  */
! 7  
! 8 /*
! 9  *  This program is free software; you can redistribute it and/or modify
! 10  *  it under the terms of the GNU General Public License as published by
! 11  *  the Free Software Foundation; either version 2 of the License, or
! 12  *  (at your option) any later version.
! 13  *
! 14  *  This program is distributed in the hope that it will be useful,
! 15  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
! 16  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! 17  *  GNU Library General Public License for more details.
! 18  *
! 19  *  You should have received a copy of the GNU General Public License
! 20  *  along with this program; if not, write to the Free Software
! 21  *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
! 22  */
! 23 
! 24 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 1 
! 1 
! 2 #ifndef __SYS_CDEFS_H
! 3 #define __SYS_CDEFS_H
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 
! 6 #if defined (__STDC__) && __STDC__
! 7 
! 8 #define	__CONCAT(x,y)	x ## y
! 9 #define	__STRING(x)	#x
! 10 
! 11 /* This is not a typedef so `const __ptr_t' does the right thing.  */
! 12 #define __ptr_t void *
! 13 typedef long double __long_double_t;
! 14 
! 15 #else
! 16 
! 17 #define	__CONCAT(x,y)	x/**/y
! 18 #define	__STRING(x)	"x"
! 19 
! 20 #define __ptr_t char *
! 21 
! 22 #ifndef __HAS_NO_FLOATS__
! 23 typedef double __long_double_t;
! 24 #endif
! 25 
! 26 #endif
! 27 
! 28 /* No C++ */
! 29 #define __BEGIN_DECLS
! 30 #define __END_DECLS
! 31 
! 32 /* GNUish things */
! 33 #define __CONSTVALUE
! 34 #define __CONSTVALUE2
! 35 
! 36 #endif
! 37 
! 37 
! 38 
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 1 
! 1 /* arch/i86/include/asm/types.h - Basic Linux/MT data types. */
! 2 
! 3 #ifndef __ARCH_8086_TYPES__
! 4 #define __ARCH_8086_TYPES__
! 5 
! 6 /* First we define all of the __u and __s types...*/
! 7 
! 8 #define signed
! 9 
! 10 typedef unsigned char   __u8;
! 11 typedef unsigned char * __pu8;
! 12 typedef   signed char   __s8;
! 13 typedef   signed char * __ps8;
! 14 
! 15 typedef unsigned short int   __u16;
! 16 typedef unsigned short int * __pu16;
! 17 typedef   signed short int   __s16;
! 18 typedef   signed short int * __ps16;
! 19 
! 20 typedef unsigned long int   __u32;
! 21 typedef unsigned long int * __pu32;
! 22 typedef   signed long int   __s32;
! 23 typedef   signed long int * __ps32;
! 24 
! 25 /* __uint == 16bit here */
! 26 
! 27 typedef unsigned short int   __uint;
! 28 typedef unsigned short int * __puint;
! 29 typedef   signed short int   __sint;
! 30 typedef   signed short int * __psint;
! 31 
! 32 /* Then we define registers, etc... */
! 33 
! 34 struct _registers {
! 35 	__u16 ksp, sp, ss, ax, bx, cx, dx, di, si, ds, es, bp, ip, cs, flags;
! 36 };
! 37 
! 38 typedef __u16 flag_t;
! 39 
! 40 typedef struct _registers __registers; 
! 41 typedef struct _registers * __pregisters;
! 42 
! 43 typedef __u16 __pptr; /* Changed to short as that is what it is */
! 44 
! 45 struct _mminit {
! 46 	__u16 cs, endcs, ds, endds, ss, endss, lowss;
! 47 };
! 48 
! 49 typedef struct _mminit   __arch_mminit;
! 50 typedef struct _mminit * __parch_mminit;
! 51 
! 52 #ifndef NULL
! 53 #define NULL	0
! 54 #endif
! 55 
! 56 #endif
! 57 
! 57 
! 58 
! 5 #include <linuxmt/posix_types.h>
! 1 
! 1 #ifndef __LINUXMT_POSIX_TYPES_H__
! 2 #define __LINUXMT_POSIX_TYPES_H__
! 3 
! 4 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 1 
! 1 /*
! 2  * Automatically generated by make menuconfig: don't edit
! 3  */
! 4 #define AUTOCONF_INCLUDED
! 5 
! 6 /*
! 7  * Advanced - for Developers and Hackers only
! 8  */
! 9 #undef  CONFIG_EXPERIMENTAL
! 10 #undef  CONFIG_OBSOLETE
! 11 #undef  CONFIG_NOT_YET
! 12 
! 13 /*
! 14  * Architecture
! 15  */
! 16 #define CONFIG_ARCH_AUTO 1
! 17 #undef  CONFIG_ARCH_IBMPC
! 18 #undef  CONFIG_ARCH_SIBO
! 19 #define CONFIG_PC_AUTO 1
! 20 #undef  CONFIG_PC_XT
! 21 #undef  CONFIG_PC_AT
! 22 #undef  CONFIG_PC_MCA
! 23 #undef  CONFIG_ROMCODE
! 24 
! 25 /*
! 26  * 286 Protected Mode Support
! 27  */
! 28 #undef  CONFIG_286PMODE
! 29 
! 30 /*
! 31  * Driver Support
! 32  */
! 33 
! 34 /*
! 35  * Character device drivers
! 36  */
! 37 #define CONFIG_CONSOLE_DIRECT 1
! 38 #undef  CONFIG_CONSOLE_BIOS
! 39 #undef  CONFIG_CONSOLE_SERIAL
! 40 #define CONFIG_DCON_VT52 1
! 41 #define CONFIG_DCON_ANSI 1
! 42 #undef  CONFIG_DCON_ANSI_PRINTK
! 43 #define CONFIG_KEYMAP_US 1
! 44 #undef  CONFIG_KEYMAP_BE
! 45 #undef  CONFIG_KEYMAP_UK
! 46 #undef  CONFIG_KEYMAP_DE
! 47 #undef  CONFIG_KEYMAP_DV
! 48 #undef  CONFIG_KEYMAP_ES
! 49 #undef  CONFIG_KEYMAP_FR
! 50 #undef  CONFIG_KEYMAP_SE
! 51 #define CONFIG_DCON_KRAW 1
! 52 #define CONFIG_CHAR_DEV_RS 1
! 53 #define CONFIG_CHAR_DEV_LP 1
! 54 #define CONFIG_CHAR_DEV_MEM 1
! 55 #define CONFIG_PSEUDO_TTY 1
! 56 #undef  CONFIG_DEV_META
! 57 
! 58 /*
! 59  * Block device drivers
! 60  */
! 61 #define CONFIG_BLK_DEV_BIOS 1
! 62 #define CONFIG_BLK_DEV_BFD 1
! 63 #define CONFIG_BLK_DEV_BHD 1
! 64 #undef  CONFIG_BLK_DEV_FD
! 65 #undef  CONFIG_BLK_DEV_HD
! 66 #undef  CONFIG_BLK_DEV_XD
! 67 #undef  CONFIG_DMA
! 68 #define CONFIG_GENDISK 1
! 69 #undef  CONFIG_BLK_DEV_RAM
! 70 #define CONFIG_BLK_DEV_CHAR 1
! 71 
! 72 /*
! 73  * Filesystems
! 74  */
! 75 #define CONFIG_MINIX_FS 1
! 76 #undef  CONFIG_ROMFS_FS
! 77 #undef  CONFIG_ELKSFS_FS
! 78 #undef  CONFIG_FULL_VFS
! 79 #define CONFIG_FS_EXTERNAL_BUFFER 1
! 80 #define CONFIG_PIPE 1
! 81 #define CONFIG_EXEC_MINIX 1
! 82 #undef  CONFIG_EXEC_MSDOS
! 83 
! 84 /*
! 85  * Network Support
! 86  */
! 87 #define CONFIG_SOCKET 1
! 88 #undef  CONFIG_NANO
! 89 #define CONFIG_INET 1
! 90 #define CONFIG_INET_STATUS 1
! 91 #undef  CONFIG_UNIX
! 92 #undef  CONFIG_SOCK_CLIENTONLY
! 93 
! 94 /*
! 95  * Kernel hacking
! 96  */
! 97 #undef  CONFIG_STRACE
! 98 #undef  CONFIG_OPT_SMALL
! 99 
! 99 
! 100 
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 5 
! 6 /*
! 7  * This file is generally used by user-level software, so you need to
! 8  * be a little careful about namespace pollution etc.  Also, we cannot
! 9  * assume GCC is being used.
! 10  */
! 11 
! 12 #ifndef NULL
! 13 # define NULL		((void *) 0)
! 14 #endif
! 15 
! 16 /*
! 17  * This allows for 20 file descriptors: if NR_OPEN is ever grown
! 18  * beyond that you'll have to change this too. For now 20 fd's seem to be
! 19  * enough for ELKS, so hopefully this won't need changing.
! 20  *
! 21  * Note that POSIX wants the FD_CLEAR(fd,fdsetp) defines to be in
! 22  * <sys/time.h> (and thus <linux/time.h>) - but this is a more logical
! 23  * place for them. Solved by having dummy defines in <sys/time.h>.
! 24  */
! 25 
! 26 /*
! 27  * Those macros may have been defined in <gnu/types.h>. But we always
! 28  * use the ones here. 
! 29  */
! 30 
! 31 #ifdef CONFIG_SHORT_FILES
! 32 
! 33 #undef __NFDBITS
! 34 #define __NFDBITS	(8 * sizeof(unsigned short))
! 35 
! 36 #undef __FD_SETSIZE
! 37 #define __FD_SETSIZE	16
! 38 
! 39 typedef __u16 __kernel_fd_set;
! 40 
! 41 #else /* CONFIG_SHORT_FILES */
! 42 
! 43 #undef __NFDBITS
! 44 #define __NFDBITS	(8 * sizeof(unsigned long))
! 45 
! 46 #undef __FD_SETSIZE
! 47 #define __FD_SETSIZE	20
! 48 
! 49 typedef __u32 __kernel_fd_set;
! 50 
! 51 #endif /* CONFIG_SHORT_FILES */
! 52 
! 53 #include <arch/posix_types.h>
! 1 
! 1 #ifndef __ARCH_8086_POSIX_TYPES_H__
! 2 #define __ARCH_8086_POSIX_TYPES_H__
! 3 
! 4 #include <arch/irq.h>
! 1 
! 1 #ifndef __ARCH_8086_IRQ_H__
! 2 #define __ARCH_8086_IRQ_H__
! 3 
! 4 #include <arch/types.h>
! 1 
! 1 /* arch/i86/include/asm/types.h - Basic Linux/MT data types. */
! 2 
! 3 #ifndef __ARCH_8086_TYPES__
! 4 #define __ARCH_8086_TYPES__
! 5 
! 6 /* First we define all of the __u and __s types...*/
! 7 
! 8 #define signed
! 9 
! 10 typedef unsigned char   __u8;
! 11 typedef unsigned char * __pu8;
! 12 typedef   signed char   __s8;
! 13 typedef   signed char * __ps8;
! 14 
! 15 typedef unsigned short int   __u16;
! 16 typedef unsigned short int * __pu16;
! 17 typedef   signed short int   __s16;
! 18 typedef   signed short int * __ps16;
! 19 
! 20 typedef unsigned long int   __u32;
! 21 typedef unsigned long int * __pu32;
! 22 typedef   signed long int   __s32;
! 23 typedef   signed long int * __ps32;
! 24 
! 25 /* __uint == 16bit here */
! 26 
! 27 typedef unsigned short int   __uint;
! 28 typedef unsigned short int * __puint;
! 29 typedef   signed short int   __sint;
! 30 typedef   signed short int * __psint;
! 31 
! 32 /* Then we define registers, etc... */
! 33 
! 34 struct _registers {
! 35 	__u16 ksp, sp, ss, ax, bx, cx, dx, di, si, ds, es, bp, ip, cs, flags;
! 36 };
! 37 
! 38 typedef __u16 flag_t;
! 39 
! 40 typedef struct _registers __registers; 
! 41 typedef struct _registers * __pregisters;
! 42 
! 43 typedef __u16 __pptr; /* Changed to short as that is what it is */
! 44 
! 45 struct _mminit {
! 46 	__u16 cs, endcs, ds, endds, ss, endss, lowss;
! 47 };
! 48 
! 49 typedef struct _mminit   __arch_mminit;
! 50 typedef struct _mminit * __parch_mminit;
! 51 
! 52 #ifndef NULL
! 53 #define NULL	0
! 54 #endif
! 55 
! 56 #endif
! 57 
! 57 
! 58 
! 5 #define save_flags(x)	x=__save_flags()
! 6 
! 7 /* Who gets which entry in bh_base. Things which will occur most often
! 8    should come first - in which case NET should be up the top with
! 9    SERIAL/TQUEUE! */
! 10 
! 11 enum {
! 12         TIMER_BH = 0,
! 13         CONSOLE_BH,
! 14         TQUEUE_BH,
! 15         DIGI_BH,
! 16         SERIAL_BH,
! 17         RISCOM8_BH,
! 18         SPECIALIX_BH,
! 19         BAYCOM_BH,
! 20         NET_BH,
! 21         IMMEDIATE_BH,
! 22         KEYBOARD_BH,
! 23         CYCLADES_BH,
! 24         CM206_BH
! 25 };
! 26 
! 27 extern void disable_irq();
! 28 extern void enable_irq();
! 29 extern void do_IRQ();
! 30 extern flag_t __save_flags();
! 31 extern void restore_flags();
! 32 extern int request_irq();
! 33 extern void free_irq();
! 34 
! 35 #if 0
! 36 extern void icli();
! 37 extern void isti();
! 38 #endif
! 39 
! 40 extern void do_bottom_half();
! 41 
! 42 extern int bh_mask_count[16];
! 43 extern unsigned bh_active;
! 44 extern unsigned bh_mask;
! 45 extern void (*bh_base[16])();
! 46 
! 47 #ifdef __KERNEL__
! 48 #define icli() asm("cli")
! 49 #define isti() asm("sti")
! 50 #else __KERNEL__
! 51 #define icli()
! 52 #define isti()
! 53 #endif
! 54 
! 55 #ifdef ENDIS_BH
! 56 
! 57 #define init_bh(nr, routine) bh_base[nr] = routine; \
! 58             bh_mask_count[nr] = 0; \
! 59             bh_mask |= 1 << nr;
! 60 
! 61 #define disable_bh(nr) bh_mask &= ~(1 << nr); bh_mask_count[nr]++;
! 62 #define enable_bh(nr) if (!--bh_mask_count[nr]) bh_mask |= 1 << nr;
! 63 
! 64 #else
! 65 
! 66 #define init_bh(nr, routine) bh_base[nr] = routine;
! 67 
! 68 #endif
! 69 
! 70 #define mark_bh(nr) set_bit(nr, &bh_active);
! 71 
! 72 #endif /* __ARCH_8086_IRQ_H */
! 73 
! 73 
! 74 
! 5 
! 6 /*
! 7  * This file is generally used by user-level software, so you need to
! 8  * be a little careful about namespace pollution etc.  Also, we cannot
! 9  * assume GCC is being used.
! 10  */
! 11 
! 12 #undef	__FD_SET
! 13 #define __FD_SET(fd,fdsetp) \
! 14                 {\
! 15                 int     mask, retval,addr=fdsetp;\
! 16 						 \
! 17                 icli(); addr += fd >> 4;\
! 18                 mask = 1 << (fd & 0xf);\
! 19                 *(int*)addr |= mask; isti(); \
! 20                 }
! 21 
! 22 #undef	__FD_CLR
! 23 #define __FD_CLR(fd,fdsetp) \
! 24                 {\
! 25                 int     mask, retval,addr=fdsetp;\
! 26                                                  \
! 27                 icli(); addr += fd >> 4;\
! 28                 mask = 1 << (fd & 0xf);\
! 29                 *(int*)addr &= ~mask; isti(); \
! 30        	        }
! 31 
! 32 #undef	__FD_ISSET
! 33 #define __FD_ISSET(fd,fdsetp) ((((unsigned long *)fdsetp)[0] & (1<<(fd & 0x1f))) != 0)
! 34 
! 35 #undef	__FD_ZERO
! 36 #define __FD_ZERO(fdsetp) (((unsigned long *)fdsetp)[0] = 0UL)
! 37 
! 38 #endif /* __ARCH_8086_POSIZ_TYPES_H */
! 39 
! 39 
! 40 
! 54 
! 55 #endif /* _LINUXMT_POSIX_TYPES_H */
! 56 
! 56 
! 57 
! 6 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 25 #include <sys/socket.h>
! 1 
! 1 
! 2 #ifndef __SYS_SOCKET_H
! 3 #define __SYS_SOCKET_H
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 #include __SYSINC__(socket.h)
! 1 
! 1 #ifndef __LINUXMT_SOCKET_H__
! 2 #define __LINUXMT_SOCKET_H__
! 3 
! 4 #include <linuxmt/uio.h>
! 1 
! 1 #ifndef __LINUXMT_UIO_H__
! 2 #define __LINUXMT_UIO_H__
! 3 
! 4 struct iovec
! 5 {
! 6 	void *iov_base;         /* BSD uses caddr_t (same thing in effect) */
! 7 	int iov_len;
! 8 };
! 9 
! 10 #define UIO_MAXIOV	16
! 11 
! 12 #endif /* _LINUXMT_UIO_H */
! 13 
! 13 
! 14 
! 5 
! 6 struct sockaddr
! 7 {
! 8 	unsigned short		sa_family;
! 9 	char			sa_data[14];
! 10 };
! 11 
! 12 struct msghdr
! 13 {
! 14 	void	*	msg_name;
! 15 	int		msg_namelen;
! 16 	struct iovec *	msg_iov;
! 17 	int		msg_iovlen;
! 18 	void	*	msg_control;
! 19 	int		msg_controllen;
! 20 	int		msg_flags;
! 21 };
! 22 
! 23 #define AF_INET	0	/* Only implemented type */
! 24 #define AF_UNIX	1
! 25 #define AF_NANO	2
! 26 
! 27 
! 28 #define PF_INET	AF_INET
! 29 #define PF_UNIX	AF_UNIX
! 30 #define PF_NANO	AF_NANO
! 31 
! 32 #define SOCK_STREAM     1               /* stream (connection) socket   */
! 33 #define SOCK_DGRAM      2               /* datagram (conn.less) socket  */
! 34 #define SOCK_RAW        3               /* raw socket                   */
! 35 #define SOCK_RDM        4               /* reliably-delivered message   */
! 36 #define SOCK_SEQPACKET  5               /* sequential packet socket     */
! 37 
! 38 
! 39 #endif /* LINUXMT_SOCKET_H */
! 40 
! 40 
! 41 
! 6 #endif
! 7 
! 7 
! 8 
! 26 #include <sys/stat.h>
! 1 
! 1 #ifndef _SYS_STAT_H
! 2 #define _SYS_STAT_H
! 3 
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 6 #include __SYSINC__(stat.h)
! 1 
! 1 #ifndef __LINUXMT_STAT_H__
! 2 #define __LINUXMT_STAT_H__
! 3 #include "types.h"
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 #include <arch/stat.h>
! 1 
! 1 #ifndef __ARCH_8086_STAT_H__
! 2 #define __ARCH_8086_STAT_H__
! 3 
! 4 struct stat {
! 5 	dev_t st_dev;
! 6 	ino_t st_ino;
! 7 	mode_t st_mode;
! 8 	nlink_t st_nlink;
! 9 	uid_t st_uid;
! 10 	gid_t st_gid;
! 11 	dev_t st_rdev;
! 12 	off_t st_size;
! 13 	time_t st_atime;
! 14 	time_t st_mtime;
! 15 	time_t st_ctime;
! 16 };
! 17 
! 18 #endif
! 19 
! 19 
! 20 
! 5 
! 6 #define S_IFMT  00170000
! 7 #define S_IFSOCK 0140000
! 8 #define S_IFLNK	 0120000
! 9 #define S_IFREG  0100000
! 10 #define S_IFBLK  0060000
! 11 #define S_IFDIR  0040000
! 12 #define S_IFCHR  0020000
! 13 #define S_IFIFO  0010000
! 14 #define S_ISUID  0004000
! 15 #define S_ISGID  0002000
! 16 #define S_ISVTX  0001000
! 17 
! 18 #define S_ISLNK(m)	(((m) & S_IFMT) == S_IFLNK)
! 19 #define S_ISREG(m)	(((m) & S_IFMT) == S_IFREG)
! 20 #define S_ISDIR(m)	(((m) & S_IFMT) == S_IFDIR)
! 21 #define S_ISCHR(m)	(((m) & S_IFMT) == S_IFCHR)
! 22 #define S_ISBLK(m)	(((m) & S_IFMT) == S_IFBLK)
! 23 #define S_ISFIFO(m)	(((m) & S_IFMT) == S_IFIFO)
! 24 #define S_ISSOCK(m)	(((m) & S_IFMT) == S_IFSOCK)
! 25 
! 26 #define S_IRWXU 00700
! 27 #define S_IRUSR 00400
! 28 #define S_IWUSR 00200
! 29 #define S_IXUSR 00100
! 30 
! 31 #define S_IRWXG 00070
! 32 #define S_IRGRP 00040
! 33 #define S_IWGRP 00020
! 34 #define S_IXGRP 00010
! 35 
! 36 #define S_IRWXO 00007
! 37 #define S_IROTH 00004
! 38 #define S_IWOTH 00002
! 39 #define S_IXOTH 00001
! 40 
! 41 #ifdef __KERNEL__
! 42 #define S_IRWXUGO	(S_IRWXU|S_IRWXG|S_IRWXO)
! 43 #define S_IALLUGO	(S_ISUID|S_ISGID|S_ISVTX|S_IRWXUGO)
! 44 #define S_IRUGO		(S_IRUSR|S_IRGRP|S_IROTH)
! 45 #define S_IWUGO		(S_IWUSR|S_IWGRP|S_IWOTH)
! 46 #define S_IXUGO		(S_IXUSR|S_IXGRP|S_IXOTH)
! 47 #endif
! 48 
! 49 #endif
! 50 
! 50 
! 51 
! 7 
! 8 int stat __P((__const char * __path, struct stat * __statbuf));
! 9 int lstat __P((__const char * __path, struct stat * __statbuf));
! 10 int fstat __P((int __fd, struct stat * __statbuf));
! 11 
! 12 /* hysterical raisins */
! 13 #define S_IREAD		S_IRUSR /* read permission, owner */
! 14 #define S_IWRITE	S_IWUSR /* write permission, owner */
! 15 #define S_IEXEC		S_IXUSR /* execute/search permission, owner */
! 16 #endif
! 17 
! 17 
! 18 
! 27 #include <fcntl.h>
! 1 
! 1 #ifndef __FCNTL__H
! 2 #define __FCNTL__H
! 3 
! 4 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 5 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 6 #include __SYSINC__(fcntl.h)
! 1 
! 1 #ifndef __LINUXMT_FCNTL_H__
! 2 #define __LINUXMT_FCNTL_H__
! 3 
! 4 /*
! 5  *	Definitions taken from the i386 Linux kernel.
! 6  */
! 7  
! 8 /* open/fcntl */
! 9 
! 10 #define O_ACCMODE	  0003
! 11 #define O_RDONLY	    00
! 12 #define O_WRONLY	    01
! 13 #define O_RDWR		    02
! 14 #define O_CREAT		  0100	/* not fcntl */
! 15 #define O_EXCL		  0200	/* not fcntl */
! 16 #define O_NOCTTY	  0400	/* not fcntl */
! 17 #define O_TRUNC		 01000	/* not fcntl */
! 18 #define O_APPEND	 02000
! 19 #define O_NONBLOCK	 04000
! 20 #define O_NDELAY	O_NONBLOCK
! 21 #if 0
! 22 #define O_SYNC		010000	/* Not supported */
! 23 #define FASYNC		020000	/* Not supported */
! 24 #endif
! 25 
! 26 #define F_DUPFD		0	/* dup */
! 27 #define F_GETFD		1	/* get f_flags */
! 28 #define F_SETFD		2	/* set f_flags */
! 29 #define F_GETFL		3	/* more flags (cloexec) */
! 30 #define F_SETFL		4
! 31 #define F_GETLK		5
! 32 #define F_SETLK		6
! 33 #define F_SETLKW	7
! 34 
! 35 #define F_SETOWN	8	/*  for sockets. */
! 36 #define F_GETOWN	9	/*  for sockets. */
! 37 
! 38 /* for F_[GET|SET]FL */
! 39 #define FD_CLOEXEC	1	/* actually anything with low bit set goes */
! 40 
! 41 /* for posix fcntl() and lockf() */
! 42 #define F_RDLCK		0
! 43 #define F_WRLCK		1
! 44 #define F_UNLCK		2
! 45 
! 46 /* for old implementation of bsd flock () */
! 47 #define F_EXLCK		4	/* or 3 */
! 48 #define F_SHLCK		8	/* or 4 */
! 49 
! 50 /* operations for bsd flock(), also used by the kernel implementation */
! 51 #define LOCK_SH		1	/* shared lock */
! 52 #define LOCK_EX		2	/* exclusive lock */
! 53 #define LOCK_NB		4	/* or'd with one of the above to prevent
! 54 				   blocking */
! 55 #define LOCK_UN		8	/* remove lock */
! 56 
! 57 #ifdef __KERNEL__
! 58 #define F_POSIX		1
! 59 #define F_FLOCK		2
! 60 #endif /* __KERNEL__ */
! 61 
! 62 #endif
! 63 
! 63 
! 64 
! 7 
! 8 #ifndef FNDELAY
! 9 #define FNDELAY	O_NDELAY
! 10 #endif
! 11 
! 12 __BEGIN_DECLS
! 13 
! 14 extern int creat __P ((__const char * __filename, mode_t __mode));
! 15 extern int fcntl __P ((int __fildes,int __cmd, ...));
! 16 extern int open __P ((__const char * __filename, int __flags, ...));
! 17 
! 18 __END_DECLS
! 19 
! 20 #endif
! 21 
! 21 
! 22 
! 28 #include <unistd.h>
! 1 
! 1 /* unistd.h <ndf@linux.mit.edu> */
! 2 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 3 #include <sys/types.h>
! 1 
! 1 #include <features.h>
! 1 
! 1 
! 2 #ifndef __FEATURES_H
! 3 #define __FEATURES_H
! 4 
! 5 #ifdef __STDC__
! 6 
! 7 #define __P(x) x
! 8 #define __const const
! 9 
! 10 /* Almost ansi */
! 11 #if __STDC__ != 1
! 12 #define const
! 13 #define volatile
! 14 #endif
! 15 
! 16 #else /* K&R */
! 17 
! 18 #define __P(x) ()
! 19 #define __const
! 20 #define const
! 21 #define volatile
! 22 
! 23 #endif
! 24 
! 25 /* Pick an OS sysinclude directory */
! 26 /* Use with #include __SYSINC__(errno.h) */
! 27 
! 28 #ifdef __ELKS__
! 29 #define __SYSINC__(_h_file_) <linuxmt/_h_file_>
! 30 #endif
! 31 
! 32 #ifdef __linux__
! 33 #undef linux	/* Eyuk! */
! 34 #define __SYSINC__(_h_file_) <linux/_h_file_>
! 35 #endif
! 36 
! 37 #ifdef __MSDOS__
! 38 #define __SYSINC__(_h_file_) <msdos/_h_file_>
! 39 #endif
! 40 
! 41 #ifndef __SYSINC__
! 42 #define __SYSINC__(_h_file_) <generic/_h_file_>
! 43 #endif
! 44 
! 45 /* No C++ */
! 46 #define __BEGIN_DECLS
! 47 #define __END_DECLS
! 48 
! 49 /* GNUish things */
! 50 #define __CONSTVALUE
! 51 #define __CONSTVALUE2
! 52 
! 53 #include <sys/cdefs.h>
! 54 
! 55 #endif
! 56 
! 56 
! 57 
! 2 #include <stddef.h>
! 1 
! 1 /* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
! 2  * This file is part of the Linux-8086 C library and is distributed
! 3  * under the GNU Library General Public License.
! 4  */
! 5 /* We don't care, ignore GCC's __need hackery */
! 6 
! 7 #ifndef __STDDEF_H
! 8 #define __STDDEF_H
! 9 
! 10 #include <sys/types.h>
! 11 
! 12 #ifndef NULL
! 13 #define NULL ((void*)0)
! 14 #endif
! 15 
! 16 #endif /* __STDDEF_H */
! 17 
! 17 
! 18 
! 3 #include __SYSINC__(types.h)
! 1 
! 1 #ifndef __LINUXMT_TYPES_H__
! 2 #define __LINUXMT_TYPES_H__
! 3 
! 4 #include <arch/types.h>
! 5 #include <linuxmt/posix_types.h>
! 6 #include <linuxmt/config.h>
! 7 
! 8 #define PRINT_STATS(a) {					\
! 9 	int __counter;						\
! 10 	printk("Entering %s : (%x, %x)\n",			\
! 11 		a, current->t_regs.sp, current->t_kstack);	\
! 12 }
! 13 
! 14 /* Throw away _FUNCTION parameters - the syntax is ripped off of Minix's
! 15    _PROTOTYPE.  Considering Borland did the same thing to MFC on a bigger
! 16    scale, I don't think PH will mind :) */
! 17 
! 18 /* Yes, this should be in arch/types.h too */
! 19 
! 20 #define _FUNCTION(function, params) function()
! 21 #define _VFUNCTION(functiom, params) (*function) ()
! 22 
! 23 typedef __s32 off_t;
! 24 typedef __s16 pid_t;
! 25 typedef __u16 uid_t;
! 26 typedef __u16 gid_t;
! 27 typedef __u16 dev_t;
! 28 typedef __u32 time_t;
! 29 typedef __u16 umode_t;
! 30 typedef __u16 nlink_t;
! 31 typedef __u16 mode_t;
! 32 typedef __u32 loff_t;
! 33 typedef __u32 speed_t;
! 34 typedef __u16 size_t;
! 35 typedef __u32 lsize_t;
! 36 typedef __u16 ino_t;
! 37 typedef __u32 u_ino_t;
! 38 typedef __u16 block_t;
! 39 typedef __u32 daddr_t;
! 40 typedef __u32 tcflag_t;
! 41 typedef __u8  cc_t;
! 42 typedef __kernel_fd_set fd_set;
! 43 typedef __u16 seg_t;			/* Segment no. */
! 44 typedef __u16 segext_t;			/* Extent of segment */
! 45 typedef __u32 jiff_t;
! 46 #ifdef CONFIG_SHORT_FILES
! 47 typedef __u16 fd_mask_t;
! 48 #else /* CONFIG_SHORT_FILES */
! 49 typedef __u32 fd_mask_t; 
! 50 #endif /* CONFIG_SHORT_FILES */
! 51 
! 52 typedef int   ptrdiff_t;
! 53 struct ustat {
! 54 	daddr_t f_tfree;
! 55 	ino_t f_tinode;
! 56 	char f_fname[6];
! 57 	char f_fpack[6];
! 58 };
! 59 
! 60 #endif
! 61 
! 62 
! 62 
! 63 
! 4 
! 4 
! 5 
! 4 
! 5 #ifndef __UNISTD_H
! 6 #define __UNISTD_H
! 7 
! 8 #define STDIN_FILENO 0
! 9 #define STDOUT_FILENO 1
! 10 #define STDERR_FILENO 2
! 11 
! 12 extern int close __P ((int));
! 13 extern size_t read __P ((int __fd, char * __buf, size_t __nbytes));
! 14 extern size_t write __P ((int __fd, __const char * __buf, size_t __n));
! 15 extern off_t lseek __P ((int __fd, off_t __n, int __whence));
! 16 extern int pipe __P ((int __pipedes[2]));
! 17 extern unsigned int alarm __P ((unsigned int __seconds));
! 18 extern unsigned int sleep __P ((unsigned int __seconds));
! 19 extern int pause __P ((void));
! 20 extern char*    crypt __P((__const char *__key, __const char *__salt));
! 21 
! 22 #ifndef SEEK_SET
! 23 #define SEEK_SET 0
! 24 #define SEEK_CUR 1
! 25 #define SEEK_END 2
! 26 #endif
! 27 
! 28 #ifndef R_OK
! 29 #define	R_OK	4		/* Test for read permission.  */
! 30 #define	W_OK	2		/* Test for write permission.  */
! 31 #define	X_OK	1		/* Test for execute permission.  */
! 32 #define	F_OK	0		/* Test for existence.  */
! 33 #endif
! 34 
! 35 #define _POSIX_VDISABLE	'\0'
! 36 
! 37 #endif /* __UNISTD_H */
! 38 
! 39 
! 40 
! 40 
! 41 
! 29 #ifndef __LINUX__
! 30 #include <linuxmt/in.h>
! 1 
! 1 #ifndef __LINUXMT_IN_H__
! 2 #define __LINUXMT_IN_H__
! 3 
! 4 struct in_addr {
! 5     unsigned long s_addr;
! 6 };
! 7 
! 8 struct sockaddr_in {
! 9 	unsigned short sin_family;	/* AF_INET */
! 10 	unsigned short sin_port;	/* port in network order */
! 11 	struct in_addr sin_addr;	
! 12 };
! 13 
! 14 #define INADDR_ANY	((unsigned long int) 0x00000000)
! 15 #define PORT_ANY	((unsigned int) 0x0000)
! 16 #define INADDR_NODE	0xffffffff
! 17 #define INADDR_LOOPBACK	0x7f000001
! 18 
! 19 #endif /* _LINUX_IN_H */
! 20 
! 20 
! 21 
! 31 #include <linuxmt/net.h>
! 1 
! 1 #ifndef __LINUXMT_NET_H__
! 2 #define __LINUXMT_NET_H__
! 3 
! 4 #include <linuxmt/config.h>
! 1 
! 1 #ifndef __LINUX_CONFIG_H__
! 2 #define __LINUX_CONFIG_H__
! 3 
! 4 #include <linuxmt/autoconf.h>
! 5 
! 6 #define REGOPT register
! 7 
! 8 /*
! 9  * Set this to 0x380 to have /dev/fd0 be the root device, or 0x3c0 for /dev/fd1 
! 10  */
! 11 
! 12 #ifndef CONFIG_ROOTDEV
! 13 /* 
! 14  * 0x0380 /dev/fd0   bios floppy
! 15  * 0x0100 /dev/ram0  ramdisk ram0      
! 16  * 0x0301 /dev/bda1  bios disk0, part 1
! 17  */
! 18 #define CONFIG_ROOTDEV 0x0380
! 19 #endif
! 20 
! 21 /*
! 22  * Use this option to download a ramdisk (/dev/ram0) with the netboot
! 23  * protocol. This ramdisk can be used as mini root disk (128KB) or
! 24  * as auxilary disk.
! 25  */
! 26 #undef CONFIG_PRELOAD_RAMDISK
! 27 
! 28 /* 
! 29  * The ramdisk is placed in the seg 0x6000 and 0x7000. So the ram is 
! 30  * reduced to 384KB main memory. This is only for test and experimental
! 31  * use.
! 32  */
! 33 #ifdef CONFIG_PRELOAD_RAMDISK
! 34 #define RAM_REDUCE 0x4000L
! 35 #else
! 36 #define RAM_REDUCE 0x0000L
! 37 #endif
! 38 
! 39 /*
! 40  * Defines for what uname() should return 
! 41  */
! 42 #ifndef UTS_SYSNAME
! 43 #define UTS_SYSNAME "ELKS"
! 44 #endif
! 45 
! 46 #ifndef UTS_MACHINE
! 47 #define UTS_MACHINE "i8086"
! 48 #endif
! 49 
! 50 #ifndef UTS_NODENAME
! 51 #define UTS_NODENAME "(none)"	/* set by sethostname() */
! 52 #endif
! 53 
! 54 #ifndef UTS_DOMAINNAME
! 55 #define UTS_DOMAINNAME "(none)"	/* set by setdomainname() */
! 56 #endif
! 57 
! 58 /*
! 59  * The definitions for UTS_RELEASE and UTS_VERSION are now defined
! 60  * in linux/version.h, and should only be used by linux/version.c
! 61  */
! 62 
! 63 /* Don't touch these, unless you really know what your doing. */
! 64 #define DEF_INITSEG	0x0100   /* original 0x0100
! 65 				  * for netboot use for example 
! 66 				  * 0x5000, as 0x0100 cannot be used
! 67 				  * in connection to the netboot
! 68 				  * loader
! 69 				  */
! 70 #define DEF_SYSSEG	0x1000
! 71 #define DEF_SETUPSEG	DEF_INITSEG + 0x20
! 72 #define DEF_SYSSIZE	0x2F00
! 73 
! 74 /* internal svga startup constants */
! 75 #define NORMAL_VGA	0xffff		/* 80x25 mode */
! 76 #define EXTENDED_VGA	0xfffe		/* 80x50 mode */
! 77 #define ASK_VGA		0xfffd		/* ask for it at bootup */
! 78 
! 79 #endif
! 80 
! 80 
! 81 
! 5 #include <linuxmt/wait.h>
! 1 
! 1 #ifndef __LINUX_WAIT_H__
! 2 #define __LINUX_WAIT_H__
! 3 
! 4 #define WNOHANG		0x00000001
! 5 #define WUNTRACED	0x00000002
! 6 
! 7 #define wake_up(_a) _wake_up(_a,1)
! 8 #define wake_up_interruptible(_a) _wake_up(_a,0)
! 9 
! 10 struct wait_queue {
! 11 	char pad;
! 12 };
! 13 
! 14 #ifdef __KERNEL__
! 15 
! 16 struct select_table_entry {
! 17 	struct wait_queue wait;
! 18 	struct wait_queue *wait_address;
! 19 };
! 20 
! 21 typedef struct select_table_struct {
! 22 	int nr;
! 23 	struct select_table_entry * entry;
! 24 } select_table;
! 25 
! 26 #define __MAX_SELECT_TABLE_ENTRIES 32
! 27 
! 28 #endif /* __KERNEL__ */
! 29 
! 30 #endif
! 31 
! 31 
! 32 
! 6 #include <linuxmt/socket.h>
! 1 
! 1 #ifndef __LINUXMT_SOCKET_H__
! 2 #define __LINUXMT_SOCKET_H__
! 3 
! 4 #include <linuxmt/uio.h>
! 5 
! 6 struct sockaddr
! 7 {
! 8 	unsigned short		sa_family;
! 9 	char			sa_data[14];
! 10 };
! 11 
! 12 struct msghdr
! 13 {
! 14 	void	*	msg_name;
! 15 	int		msg_namelen;
! 16 	struct iovec *	msg_iov;
! 17 	int		msg_iovlen;
! 18 	void	*	msg_control;
! 19 	int		msg_controllen;
! 20 	int		msg_flags;
! 21 };
! 22 
! 23 #define AF_INET	0	/* Only implemented type */
! 24 #define AF_UNIX	1
! 25 #define AF_NANO	2
! 26 
! 27 
! 28 #define PF_INET	AF_INET
! 29 #define PF_UNIX	AF_UNIX
! 30 #define PF_NANO	AF_NANO
! 31 
! 32 #define SOCK_STREAM     1               /* stream (connection) socket   */
! 33 #define SOCK_DGRAM      2               /* datagram (conn.less) socket  */
! 34 #define SOCK_RAW        3               /* raw socket                   */
! 35 #define SOCK_RDM        4               /* reliably-delivered message   */
! 36 #define SOCK_SEQPACKET  5               /* sequential packet socket     */
! 37 
! 38 
! 39 #endif /* LINUXMT_SOCKET_H */
! 40 
! 40 
! 41 
! 7 
! 8 /* Number of protocols */
! 9 #define NPROTO 3
! 10 
! 11 #define SOCK_INODE(S)	((S)->inode)
! 12 
! 13 typedef enum {
! 14 	SS_FREE = 0,
! 15 	SS_UNCONNECTED,
! 16 	SS_CONNECTING,
! 17 	SS_CONNECTED,
! 18 	SS_DISCONNECTING
! 19 } socket_state;
! 20 
! 21 struct socket {
! 22 	short			type;
! 23 	unsigned char		state;
! 24 	long			flags;
! 25 	struct proto_ops	*ops;
! 26 	void			*data;
! 27 #if defined(CONFIG_INET)
! 28 	int	avail_data;	/* I added this here for smaller code and memory use - HarKal */
! 29 	short  sem;
! 30 #endif
! 31 #if defined(CONFIG_UNIX) || defined(CONFIG_NANO) || defined(CONFIG_INET)
! 32 	struct socket		*conn;
! 33 	struct socket		*iconn;
! 34 	struct socket		*next;
! 35 #endif /* CONFIG_UNIX || CONFIG_NANO */
! 36 	struct wait_queue	*wait;
! 37 	struct inode		*inode;
! 38 	struct fasync_struct	*fasync_list;
! 39 	struct file		*file;
! 40 };
! 41 
! 42 struct proto_ops {
! 43 	int	family;
! 44 	int	(*create)	();
! 45 	int	(*dup)		();
! 46 	int	(*release)	();
! 47 	int	(*bind)		();
! 48 	int	(*connect)	();
! 49  	int	(*socketpair)	();
! 50 	int	(*accept)	();
! 51 	int	(*getname)	();
! 52 	int	(*read)		();
! 53 	int	(*write)	();
! 54 	int	(*select)	();
! 55 	int	(*ioctl)	();
! 56 	int	(*listen)	();
! 57 	int	(*send)		();
! 58 	int	(*recv)		();
! 59 	int	(*sendto)	();
! 60 	int	(*recvfrom)	();
! 61 	int	(*shutdown)	();
! 62 	int	(*setsocketopt)	();
! 63 	int	(*getsocketopt)	();
! 64 	int	(*fcntl)	();
! 65 };
! 66 
! 67 #define SO_ACCEPTCON	(1<<13)
! 68 #define SO_WAITDATA	(1<<14)
! 69 #define SO_NOSPACE	(1<<15)
! 70 
! 71 struct net_proto {
! 72 	char *name;               /* Protocol name */
! 73 	void (*init_func)();  /* Bootstrap */
! 74 };
! 75 
! 76 
! 77 #endif /* LINUXMT_NET_H */
! 78 
! 78 
! 79 
! 32 #include "mylib.h"
! 1 
! 1 #ifndef __MYLIB_H__
! 2 #define __MYLIB_H__
! 3 
! 4 #ifndef ntohs
! 5 #define ntohs(x)	( ((x) >> 8 & 0xff)|((x) << 8) )
! 6 #define htons(x)	ntohs(x)
! 7 #endif
! 8 
! 9 #define ntohl(x)	( 		(((x) >> 24)&0xff)| \
! 10 							(((x) >> 8 )&0xff00)| \
! 11 							(((x) & 0xff00) << 8)| \
! 12 							(((x) & 0xff) << 24) )
! 13 
! 14 #define	htonl(x)	ntohl(x)
! 15 							
! 16 
! 17 #endif
! 18 
! 18 
! 19 
! 33 #else
! 34 #include <netinet/in.h>
! 35 #include <arpa/inet.h>
! 36 #endif
! 37 
! 38 #define DEF_PORT		80
! 39 #define DEF_DOCBASE	"/usr/lib/httpd"
! 40 #define DEF_CONTENT	"text/html"
! 41 
! 42 #define WS(c)	( ((c) == ' ') || ((c) == '\t') || ((c) == '\r') || ((c) == '\n') )
! 43 
! 44 int listen_sock;
! 45 int conn_sock;
! 46 #define BUF_SIZE	2048
! 47 char buf[BUF_SIZE];
! 48 char doc_base[64];
! 49 
! 50 #if 1
! 51 char* get_mime_type(name)
! 52 char* name;
export	_get_mime_type
_get_mime_type:
! 53 {
! 54     char* dot;
! 55 
! 56     dot = strrchr( name, '.' );
push	bp
mov	bp,sp
push	di
push	si
dec	sp
dec	sp
mov	ax,*$2E
push	ax
push	4[bp]
call	_strrchr
add	sp,*4
mov	-6[bp],ax
!mov	ax,ax
test	ax,ax
jne 	.1
.2:
! 58 	return "text/plain";
mov	ax,#.3
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 59     if ( strcmp( dot, ".html" ) == 0 || strcmp( dot, ".htm" ) == 0 )
.1:
mov	bx,#.5
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
je  	.7
.8:
mov	bx,#.6
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.4
.7:
! 60 	return "text/html";
mov	ax,#.9
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 61     if ( strcmp( dot, ".jpg" ) == 0 || strcmp( dot, ".jpeg" ) == 0 )
.4:
mov	bx,#.B
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
je  	.D
.E:
mov	bx,#.C
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.A
.D:
! 62 	return "image/jpeg";
mov	ax,#.F
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 63     if ( strcmp( dot, ".gif" ) == 0 )
.A:
mov	bx,#.11
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.10
.12:
! 64 	return "image/gif";
mov	ax,#.13
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 65     if ( strcmp( dot, ".png" ) == 0 )
.10:
mov	bx,#.15
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.14
.16:
! 66 	return "image/png";
mov	ax,#.17
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 67     if ( strcmp( dot, ".css" ) == 0 )
.14:
mov	bx,#.19
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.18
.1A:
! 68 	return "text/css";
mov	ax,#.1B
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 69     if ( strcmp( dot, ".vrml" ) == 0 || strcmp( dot, ".wrl" ) == 0 )
.18:
mov	bx,#.1D
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
je  	.1F
.20:
mov	bx,#.1E
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.1C
.1F:
! 70 	return "model/vrml";
mov	ax,#.21
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 71     if ( strcmp( dot, ".midi" ) == 0 || strcmp( dot, ".m
.1C:
! 71 id" ) == 0 )
mov	bx,#.23
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
je  	.25
.26:
mov	bx,#.24
push	bx
push	-6[bp]
call	_strcmp
add	sp,*4
test	ax,ax
jne 	.22
.25:
! 72 	return "audio/midi";
mov	ax,#.27
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 73     return "text/plain";
.22:
mov	ax,#.28
inc	sp
inc	sp
pop	si
pop	di
pop	bp
ret
! 74 }
! 75 #endif
! 76 
! 77 void send_header(ct)
! 78 char *ct;
export	_send_header
_send_header:
! 79 {
! 80 	buf[0] = 0;
push	bp
mov	bp,sp
push	di
push	si
xor	al,al
mov	[_buf],al
! 81 	sprintf(buf, "HTTP/1.0 200 OK\r\nServer: nanoHTTPd/0.1\r\nDate: Thu Apr 26 15:37:46 GMT 2001\r\nContent-Type: %s\r\n",ct);
push	4[bp]
mov	bx,#.29
push	bx
mov	bx,#_buf
push	bx
call	_sprintf
add	sp,*6
! 82 	write(conn_sock, buf, strlen(buf));
mov	bx,#_buf
push	bx
call	_strlen
inc	sp
inc	sp
push	ax
mov	bx,#_buf
push	bx
push	[_conn_sock]
call	_write
add	sp,*6
! 83 }
pop	si
pop	di
pop	bp
ret
! 84 
! 85 void send_error(errnum, str)
! 86 int	errnum;
export	_send_error
_send_error:
! 87 char *str;
! 88 {
! 89 	buf[0] = 0;
push	bp
mov	bp,sp
push	di
push	si
xor	al,al
mov	[_buf],al
! 90 	sprintf(buf,"HTTP/1.0 %d %s\r\nContent-type: %s\r\n", errnum, str, DEF_CONTENT);
mov	bx,#.2B
push	bx
push	6[bp]
push	4[bp]
mov	bx,#.2A
push	bx
mov	bx,#_buf
push	bx
call	_sprintf
add	sp,*$A
! 91 	write(conn_sock, buf, strlen(buf));
mov	bx,#_buf
push	bx
call	_strlen
inc	sp
inc	sp
push	ax
mov	bx,#_buf
push	bx
push	[_conn_sock]
call	_write
add	sp,*6
! 92 	buf[0] = 0;
xor	al,al
mov	[_buf],al
! 93 	sprintf(buf,"Connection: close\r\nDate: Thu Apr 26 15:37:46 GMT 2001\r\n\r\n%s\r\n",str);
push	6[bp]
mov	bx,#.2C
push	bx
mov	bx,#_buf
push	bx
call	_sprintf
add	sp,*6
! 94 	write(conn_sock, buf, strlen(buf));
mov	bx,#_buf
push	bx
call	_strlen
inc	sp
inc	sp
push	ax
mov	bx,#_buf
push	bx
push	[_conn_sock]
call	_write
add	sp,*6
! 95 }
pop	si
pop	di
pop	bp
ret
! 96 
! 97 void process_request()
! 98 {
export	_process_request
_process_request:
! 99 	int p;
! 100 	int fin, size;
! 101 	int ret;
! 102 	char *c, *file, fullpath[128];
! 103 	struct stat st;
! 104 	
! 105 	ret = read(conn_sock, buf, BUF_SIZE);
push	bp
mov	bp,sp
push	di
push	si
add	sp,#-$AA
mov	ax,#$800
push	ax
mov	bx,#_buf
push	bx
push	[_conn_sock]
call	_read
add	sp,*6
mov	-$C[bp],ax
! 106 	
! 107 	c = buf;
mov	bx,#_buf
mov	-$E[bp],bx
! 108 	while(*c && !WS(*c) && c < (buf + sizeof(buf))){
jmp .2E
.2F:
! 109 		c++;
inc	word ptr -$E[bp]
.2E:
mov	bx,-$E[bp]
mov	al,[bx]
test	al,al
je  	.30
.32:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*$20
je  	.30
.35:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*9
je  	.30
.34:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*$D
je  	.30
.33:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*$A
je  	.30
.31:
mov	bx,#_buf+$800
cmp	bx,-$E[bp]
ja 	.2F
.30:
.2D:
mov	bx,-$E[bp]
xor	al,al
mov	[bx],al
! 112 	
! 113 	if(strcasecmp(buf, "get")){
mov	bx,#.37
push	bx
mov	bx,#_buf
push	bx
call	_strcasecmp
add	sp,*4
test	ax,ax
je  	.36
.38:
! 114 		send_error(404, "Method not supported");
mov	bx,#.39
push	bx
mov	ax,#$194
push	ax
call	_send_error
add	sp,*4
! 115 		return;		
lea	sp,-4[bp]
pop	si
pop	di
pop	bp
ret
! 116 	}
! 117 	
! 118 	file = ++c;
.36:
inc	word ptr -$E[bp]
mov	bx,-$E[bp]
mov	-$10[bp],bx
! 119 	while(*c && !WS(*c) && c < (buf + sizeof(buf))){
jmp .3B
.3C:
! 120 		c++;
inc	word ptr -$E[bp]
.3B:
mov	bx,-$E[bp]
mov	al,[bx]
test	al,al
je  	.3D
.3F:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*$20
je  	.3D
.42:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*9
je  	.3D
.41:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*$D
je  	.3D
.40:
mov	bx,-$E[bp]
cmp	byte ptr [bx],*$A
je  	.3D
.3E:
mov	bx,#_buf+$800
cmp	bx,-$E[bp]
ja 	.3C
.3D:
.3A:
mov	bx,-$E[bp]
xor	al,al
mov	[bx],al
! 123 
! 124 	/* TODO : Use strncat when security is the only problem of this server! */
! 125 	strcpy(fullpath, doc_base);
mov	bx,#_doc_base
push	bx
lea	bx,-$90[bp]
push	bx
call	_strcpy
add	sp,*4
! 126 	strcat(fullpath, file);
push	-$10[bp]
lea	bx,-$90[bp]
push	bx
call	_strcat
add	sp,*4
! 127 	stat(fullpath, &st);
lea	bx,-$AE[bp]
push	bx
lea	bx,-$90[bp]
push	bx
call	_stat
add	sp,*4
! 128 	
! 129 	if((st.st_mode & S_IFMT) == S_IFDIR){
mov	ax,-$AA[bp]
and	ax,#$F000
cmp	ax,#$4000
jne 	.43
.44:
! 130 		if(file[strlen(fullpath) - 1] != '/'){
lea	bx,-$90[bp]
push	bx
call	_strlen
inc	sp
inc	sp
dec	ax
add	ax,-$10[bp]
mov	bx,ax
cmp	byte ptr [bx],*$2F
je  	.45
.46:
! 131 			strcat(fullpath, "/");
mov	bx,#.47
push	bx
lea	bx,-$90[bp]
push	bx
call	_strcat
add	sp,*4
! 132 		}
! 133 		strcat(fullpath, "index.html");
.45:
mov	bx,#.48
push	bx
lea	bx,-$90[bp]
push	bx
call	_strcat
add	sp,*4
! 134 	}
! 135 	
! 136 	fin = open(fullpath, O_RDONLY);
.43:
xor	ax,ax
push	ax
lea	bx,-$90[bp]
push	bx
call	_open
add	sp,*4
mov	-8[bp],ax
!mov	ax,ax
test	ax,ax
jge 	.49
.4A:
! 138 		send_error(404, "Document (probably) not found");
mov	bx,#.4B
push	bx
mov	ax,#$194
push	ax
call	_send_error
add	sp,*4
! 139 		return;
lea	sp,-4[bp]
pop	si
pop	di
pop	bp
ret
! 140 	}
! 141 	size = lseek(fin, 0, SEEK_END);
.49:
mov	ax,2
push	ax
xor	ax,ax
push	ax
push	-8[bp]
call	_lseek
mov	bx,dx
add	sp,*6
mov	-$A[bp],ax
! 142 	perror("oups!\n");
mov	bx,#.4C
push	bx
call	_perror
inc	sp
inc	sp
! 143 	lseek(fin, 0, SEEK_SET);
xor	ax,ax
push	ax
xor	ax,ax
push	ax
push	-8[bp]
call	_lseek
mov	bx,dx
add	sp,*6
! 144 	send_header(get_mime_type(fullpath));
lea	bx,-$90[bp]
push	bx
call	_get_mime_type
inc	sp
inc	sp
push	ax
call	_send_header
inc	sp
inc	sp
! 145 	buf[0] = 0;
xor	al,al
mov	[_buf],al
! 146 	sprintf(buf,"Content-Length: %d\r\n\r\n",size);
push	-$A[bp]
mov	bx,#.4D
push	bx
mov	bx,#_buf
push	bx
call	_sprintf
add	sp,*6
! 147 	write(conn_sock, buf, strlen(buf));
mov	bx,#_buf
push	bx
call	_strlen
inc	sp
inc	sp
push	ax
mov	bx,#_buf
push	bx
push	[_conn_sock]
call	_write
add	sp,*6
! 148 	
! 149 	do {
.50:
! 150 		ret = read(fin, buf, BUF_SIZE);
mov	ax,#$800
push	ax
mov	bx,#_buf
push	bx
push	-8[bp]
call	_read
add	sp,*6
mov	-$C[bp],ax
push	ax
mov	bx,#_buf
push	bx
push	[_conn_sock]
call	_write
add	sp,*6
! 152 	} while (ret == BUF_SIZE);
.4F:
cmp	word ptr -$C[bp],#$800
je 	.50
.51:
! 153 	
! 154 	close(fin);
.4E:
push	-8[bp]
call	_close
inc	sp
inc	sp
! 155 	
! 156 }
lea	sp,-4[bp]
pop	si
pop	di
pop	bp
ret
! 157 
! 158 int main(argc, argv)
! 159 int argc;
export	_main
_main:
! 160 char** argv;
! 161 {
.globl	___mkargv
! 162 	int ret;
! 163 	unsigned long i;
! 164 	char *t;
! 165 	struct sockaddr_in localadr;
! 166 
! 167 	strcpy(doc_base, DEF_DOCBASE);
push	bp
mov	bp,sp
push	di
push	si
add	sp,*-$10
mov	bx,#.52
push	bx
mov	bx,#_doc_base
push	bx
call	_strcpy
add	sp,*4
! 168 	
! 169 	listen_sock = socket(AF_INET, SOCK_STREAM, 0);
xor	ax,ax
push	ax
mov	ax,*1
push	ax
xor	ax,ax
push	ax
call	_socket
add	sp,*6
mov	[_listen_sock],ax
! 170 	
! 171 	localadr.sin_family = AF_INET;
xor	ax,ax
mov	-$14[bp],ax
! 172 	localadr.sin_port = htons(DEF_PORT);
mov	ax,#$5000
mov	-$12[bp],ax
! 173 	localadr.sin
! 173 _addr.s_addr = INADDR_ANY;
xor	ax,ax
xor	bx,bx
mov	-$10[bp],ax
mov	-$E[bp],bx
! 174 
! 175 	ret = bind(	listen_sock,
! 176     			(struct sockaddr *)&localadr,
! 177     			sizeof(struct sockaddr_in));
mov	ax,*8
push	ax
lea	bx,-$14[bp]
push	bx
push	[_listen_sock]
call	_bind
add	sp,*6
mov	-6[bp],ax
! 178 
! 179 	ret = listen(listen_sock, 5);
mov	ax,*5
push	ax
push	[_listen_sock]
call	_listen
add	sp,*4
mov	-6[bp],ax
! 180 
! 181 	while(1){
.55:
! 182 		conn_sock = accept(listen_sock, NULL, NULL);
xor	ax,ax
push	ax
xor	ax,ax
push	ax
push	[_listen_sock]
call	_accept
add	sp,*6
mov	[_conn_sock],ax
!mov	ax,ax
test	ax,ax
jge 	.56
.57:
! 185 			continue;
jmp .54
! 186 			
! 187 		ret = fork();
.56:
call	_fork
mov	-6[bp],ax
!mov	ax,ax
test	ax,ax
jne 	.58
.59:
! 189 			close(listen_sock);
push	[_listen_sock]
call	_close
inc	sp
inc	sp
! 190 			process_request();
call	_process_request
! 191 			close(conn_sock);
push	[_conn_sock]
call	_close
inc	sp
inc	sp
! 192 			exit(0);
xor	ax,ax
push	ax
call	_exit
inc	sp
inc	sp
! 193 		} else {
jmp .5A
.58:
! 194 			close(conn_sock);
push	[_conn_sock]
call	_close
inc	sp
inc	sp
! 195 		}
! 196 	}
.5A:
! 197 }
.54:
jmp	.55
.5B:
.53:
add	sp,*$10
pop	si
pop	di
pop	bp
ret
! 198 
! 199 
.data
.52:
.5C:
.ascii	"/usr/lib/httpd"
.byte	0
.4D:
.5D:
.ascii	"Content-Length: %d"
.byte	$D,$A,$D,$A
.byte	0
.4C:
.5E:
.ascii	"oups!"
.byte	$A
.byte	0
.4B:
.5F:
.ascii	"Document (probably) not found"
.byte	0
.48:
.60:
.ascii	"index.html"
.byte	0
.47:
.61:
.ascii	"/"
.byte	0
.39:
.62:
.ascii	"Method not supported"
.byte	0
.37:
.63:
.ascii	"get"
.byte	0
.2C:
.64:
.ascii	"Connection: close"
.byte	$D,$A
.ascii	"Date: Thu Apr 26 15:37:46 GMT 2001"
.byte	$D,$A,$D,$A
.ascii	"%s"
.byte	$D,$A
.byte	0
.2B:
.65:
.ascii	"text/html"
.byte	0
.2A:
.66:
.ascii	"HTTP/1.0 %d %s"
.byte	$D,$A
.ascii	"Content-type: %s"
.byte	$D,$A
.byte	0
.29:
.67:
.ascii	"HTTP/1.0 200 OK"
.byte	$D,$A
.ascii	"Server: nanoHTTPd/0.1"
.byte	$D,$A
.ascii	"Date: Thu Apr 26 15:37:46 GMT 2001"
.byte	$D,$A
.ascii	"Content-Type: %s"
.byte	$D,$A
.byte	0
.28:
.68:
.ascii	"text/plain"
.byte	0
.27:
.69:
.ascii	"audio/midi"
.byte	0
.24:
.6A:
.ascii	".mid"
.byte	0
.23:
.6B:
.ascii	".midi"
.byte	0
.21:
.6C:
.ascii	"model/vrml"
.byte	0
.1E:
.6D:
.ascii	".wrl"
.byte	0
.1D:
.6E:
.ascii	".vrml"
.byte	0
.1B:
.6F:
.ascii	"text/css"
.byte	0
.19:
.70:
.ascii	".css"
.byte	0
.17:
.71:
.ascii	"image/png"
.byte	0
.15:
.72:
.ascii	".png"
.byte	0
.13:
.73:
.ascii	"image/gif"
.byte	0
.11:
.74:
.ascii	".gif"
.byte	0
.F:
.75:
.ascii	"image/jpeg"
.byte	0
.C:
.76:
.ascii	".jpeg"
.byte	0
.B:
.77:
.ascii	".jpg"
.byte	0
.9:
.78:
.ascii	"text/html"
.byte	0
.6:
.79:
.ascii	".htm"
.byte	0
.5:
.7A:
.ascii	".html"
.byte	0
.3:
.7B:
.ascii	"text/plain"
.byte	0
.bss
.comm	_buf,$800
.comm	_conn_sock,2
.comm	_doc_base,$40
.comm	_listen_sock,2
! 0 errors detected
